/******************************************************************************
* DISCLAIMER

* This software is supplied by Renesas Technology Corp. and is only 
* intended for use with Renesas products. No other uses are authorized.

* This software is owned by Renesas Technology Corp. and is protected under 
* all applicable laws, including copyright laws.

* THIS SOFTWARE IS PROVIDED "AS IS" AND RENESAS MAKES NO WARRANTIES 
* REGARDING THIS SOFTWARE, WHETHER EXPRESS, IMPLIED OR STATUTORY, 
* INCLUDING BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, FITNESS FOR A 
* PARTICULAR PURPOSE AND NON-INFRINGEMENT.  ALL SUCH WARRANTIES ARE EXPRESSLY 
* DISCLAIMED.

* TO THE MAXIMUM EXTENT PERMITTED NOT PROHIBITED BY LAW, NEITHER RENESAS 
* TECHNOLOGY CORP. NOR ANY OF ITS AFFILIATED COMPANIES SHALL BE LIABLE 
* FOR ANY DIRECT, INDIRECT, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES 
* FOR ANY REASON RELATED TO THE THIS SOFTWARE, EVEN IF RENESAS OR ITS 
* AFFILIATES HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.

* Renesas reserves the right, without notice, to make changes to this 
* software and to discontinue the availability of this software.  
* By using this software, you agree to the additional terms and 
* conditions found by accessing the following link:
* http://www.renesas.com/disclaimer
********************************************************************************
* Copyright (C) 2009. Renesas Technology Corp., All Rights Reserved.           *
********************************************************************************/

/*""FILE COMMENT""*********** Technical reference data *************************
 *
 *       System Name : SH7264 USB FUNCTION Sample Program
 *       File Name   : main.c
 *       Abstract    : Sample Program Main
 *       Version     : 1.03.00
 *       Device      : SH7264/SH7262
 *       Tool-Chain  : High-performance Embedded Workshop (Ver.4.04.01).
 *                   : C/C++ compiler package for the SuperH RISC engine family
 *                   :                             (Ver.9.02 Release00).
 *       OS          : None
 *       H/W Platform: M3A-HS64G50(CPU board)
 *
 *       History   : May.13.2009 ver.1.00.00
 *                 : Jul.06.2009 ver.1.01.00 Changed common directory
 *                 : Jul.13.2009 ver.1.02.00 Tool-Chain 9.2.0.0
 *                 : Nov.10.2009 ver.1.03.00 Changed common directory
 *""FILE COMMENT END""**********************************************************/
#include <stdio.h>
#include <string.h>
#include <machine.h>
#include <math.h>
#include "iodefine.h"       /* SH7264 iodefine  */
#include "m3a_hs64.h"
#include "usb.h"
#include "usb_firm.h"
#include "cache.h"
#include "common.h"


/* ---- MMf[^ 2ʂ݂ɓւċpp---- */

unsigned long Data0[2][(SSI_DATASIZE + BUF_SIZE_USB0)/4];


unsigned int BuffIdx0,BuffIdx1;   // Data0[BuffIdx][]
unsigned int BuffIdx_bulkin;
unsigned int BuffIdx_bulkin_old;


/*----- bulkout message ------*/
unsigned char message_bulkout[4][2];

 
/*------  fir̎fft̎ ------*/
#define M_PI 3.14159265358979
#define alfa0 9.95106
#define com_order2 127
#define com_order 255 
#define wc0 0.899999998509884
#define klen0 512
#define klen0_half 256
#define nzyoux 9
#define NUM_LOOP 256 // SSI_DATASIZE2/klen0_hal

int    kaiser_fft_flag0;


// Sf[^̈RAM̃ZbVɂƋNȂȂB
// STACK̈gł̂ŒӁB
#pragma section WDATA //̃ZbVRAMɒ`
double mk[klen0 * 2];    // cos,siňWe[u        //8k
double works[klen0 * 2];  // Ɨ̈       //8k
//@܂łŃX^bN̈ɐiĂ@stack ̎c12k
#pragma section

double works_half[klen0_half * 2]; 

#pragma section CDATA  //eRAM̃LbVΉAhX̃ZbVƂĒ`B
double kaiser_lpf2[klen0 * 2];   // FIR tB^[̉FFT̂i[ĂB
#pragma section


union {
	int i0;
	char   c0[4];
} uic0;

unsigned char msg0[65];


/* ==== vg^Cv錾 ==== */
void init_ssif(void);
void io_init_dma1(void *src, void *rsrc, void *dst, void *src2, void *dst2, void *rdst2);
void set_data0(void);
void init_kaiserlpf_fft(void);
int f_fft_overlap_add2(short *in0, int count0);

#define BULK_OUT_PIPE	PIPE1
#define BULK_IN_PIPE	PIPE2



extern int CDC_start_snd( unsigned long size, unsigned char *top );
extern int CDC_start_rcv( unsigned long size, unsigned char *buf );
extern int CDC_check_complete( unsigned short Pipe );



extern unsigned char		LineCodingItem[];
// /*	Line Coding Structure	*/
// unsigned char		LineCodingItem[] = {
//	0x00,0xC2,0x01,0x00,	/*	0-3	dwDTERate 	Bit Rate(bps)	Default : 0x1C200 (115200)	*/
//	0x00,					/*	 4	bCharFormat Stop BIt		Default : 0 (1 Stop bit)	*/
//	0x00,					/*	 5	bCharFormat Parity			Default : 0 (None )			*/
//	0x08,					/*	 6	bCharFormat Data Bit		Default : 8					*/
//	0x00					/*	 7	bCharFormat Flow Control	Default : 0 (SW or None)	*/
//};



/*""FUNC COMMENT""*******************************************************
 * Outline     : main
 *-----------------------------------------------------------------------
 * Include     : 
 *-----------------------------------------------------------------------
 * Declaration : void main(void);
 *-----------------------------------------------------------------------
 * Description : 
 *-----------------------------------------------------------------------
 * Argument    : void
 *-----------------------------------------------------------------------
 * Return Value: void
 *-----------------------------------------------------------------------
 * Notice      : 
 *""FUNC COMMENT END""***************************************************/
 

void main(void)
{	
	int i, f, l;
	unsigned char c, *p;
	int count0,size0;
	short *in0;
      
	// LbV@LɂĂ݂B  
    CCNT.CCR1.LONG = 0x00000909;                          /* ICI=ICE=OCI=OCE=1      */
    if( CCNT.CCR1.LONG )  ;                               /* Dummy Read             */
                                                          /* WT=0 (write back)      */	


        /* PB21 ɒǉLED̐̂߂̏ݒ */
		/* ƕt^ɂƂƂĂLED̐̂߂̏ */
		/* PG14ɒǉLED̐̂߂̏ݒ  */
	    /*--- PBCR5ݒ PB21̐ݒ ---*/	
	    PORT.PBCR5.WORD &= 0xFF0Fu;
		PORT.PCCR2.WORD &= 0xFFF0u;
		PORT.PGCR3.WORD &= 0xF0FFu;

    	/*--- PBIOR1ݒ PB21LEDo͂ɐݒ ---*/
	    PORT.PBIOR1.WORD |= 0x0020u;
		PORT.PCIOR0.WORD |= 0x0100u;
		PORT.PGIOR0.WORD |= 0x4000u;
	
     	/*--- PBDR1ݒ PB21Low ---*/
     	PORT.PBDR1.BYTE.L &= 0xDFu;
		PORT.PCDR0.BYTE.H &= 0xFEu;
		PORT.PGDR0.BYTE.H &= 0xBFu;


	  
    	/* f[^̏  */
		set_data0();

       
       /*-- DMAC ̏ݒ ---- */
	  /*  SSI2M   SSI3M   */
	   BuffIdx0 = 0u;	   
       BuffIdx1 = 1u;  
       io_init_dma1( Data0[0], Data0[1], (void *)&SSIF2.SSIFTDR,(void *)&SSIF3.SSIFRDR, Data0[1], Data0[0]);
       
	   /*-- SSI ̏ݒ ---- */ 
       init_ssif();	   
	   
	  /*-- USB bulkout ̃bZ[W --*/
	   message_bulkout[0][0]=0x30;
	   message_bulkout[1][0]=0x31;   		
	

     
	  set_fpscr( 0xC0001 );  //SH-2A FPU DOUBLE̐ݒ莞
	  kaiser_fft_flag0=0;
	  init_kaiserlpf_fft();
	
	
	
	P_ModeInit();

#ifndef USB_ONLY0
        io_init_scif2();
#endif

   
   
re_start0:
   // HOST@PC̋NMiXgbvrbgPȏj҂B
   while(1){
	  if(LineCodingItem[4] >= 0) break; 
   }


/*  BuffIdx Zbg */	
    BuffIdx_bulkin=BuffIdx0;
	BuffIdx_bulkin^= 1u;
    BuffIdx_bulkin_old=BuffIdx_bulkin;

	
/*    USB@f[^̓ǂݍ݂̌JԂ@@@*/	
while(1){  //@
	 
	//  HOST@PĆiXgbvrbgOjҋ@ցB
	if(LineCodingItem[4] == 0)
	{
		set_data0();
		goto re_start0;
	}



	if(  BuffIdx_bulkin_old != BuffIdx_bulkin) // A
	{	
	  BuffIdx_bulkin_old=BuffIdx_bulkin;
	  p=(unsigned char *)Data0[BuffIdx_bulkin];
	  
	  
	 //t^ɂƂƂĂLED_ 
	 PORT.PCDR0.BYTE.H &= 0xFEu;
	 //////////////////////////////////////
	 
	 /*------ USB bZ[W̑M -----*/ 
	 l=0;
	 while(1){
	  if( CDC_start_snd(1,message_bulkout[BuffIdx_bulkin]) == 0) break;
	  if(l>0x100000) { break; } else{ ++l; }
	 }	
	 /*------ bZ[W̑M܂ő҂ -----*/
	 l=0;

	 while( !(CDC_check_complete(BULK_IN_PIPE)) ){	 		 
	  if(l>0x100000) { break; } else{ ++l; }
		/* wait */
	 }	
	 
	 count0=0;	 f=0;  	 
	 while( count0 < SSI_DATASIZE )
	 {
	     /*------ USB f[^̎M -----*/ 
	     l=0;
	      while(1){
	      if( CDC_start_rcv(BUF_SIZE_USB0,p) == 0) break;	  
           if(l > 0x200000) { break; } else{ ++l;++f;}
	     }	
	     /*------ f[^M܂ő҂ -----*/
	     l=0;
	      while( !(CDC_check_complete(BULK_OUT_PIPE)) ){
		    if(l> 0x100000) { break; } 	else{ ++l; ++f;}
	      	/* wait */
	     }			 

		  
		 size0 = BUF_SIZE_USB0 - USBDataCount[ BULK_OUT_PIPE ];
	     count0 +=size0;
		 p += size0;
		
		 if(f > 0x200000) { break; } 
	 }
	 
	 if( count0 >= SSI_DATASIZE) {
	 /*--- PBDR1ݒ PB21Low ---*/
	 /* LED@ */
         PORT.PBDR1.BYTE.L &= 0xDFu;  
	 }
	 else
	 {
#ifdef FIFO_DMA_OUT
               //  IɎMI点B
               /* D0FIFO DMA stop   */
               DMAC.CHCR5.BIT.DE    = 0;		/* DMA transfer disabled */
               DMAC.CHCR5.BIT.TE     = 0;		/* Transfer end flag clear */
               if( DMAC.CHCR5.BIT.TS == 0 ) {
		         PipeDataSize[BULK_OUT_PIPE] -= DMAC.DMATCR5.LONG;			/* 8bit		*/
	            }
	            else if( DMAC.CHCR5.BIT.TS == 1 ){
		         PipeDataSize[BULK_OUT_PIPE] -= (DMAC.DMATCR5.LONG * 2);			/* 16bit	*/
               }
	            else if( DMAC.CHCR5.BIT.TS == 2 ){
		         PipeDataSize[BULK_OUT_PIPE] -= (DMAC.DMATCR5.LONG * 4);			/* 32bit	*/
	           }
	           USB.D0FIFOSEL.BIT.DREQE = 0;     // DMAN֎~
               USB.D0FIFOCTR.WORD = BITBCLR;    // obt@NA[
               PipeFlag[BULK_OUT_PIPE] = PIPE_DONE;
		     
#endif


             // ۂɎMf[^zXgPC֑B 
             f=0;

		     msg0[0]=0x69; f++;   // char i
             uic0.i0=	count0;			
			 for(l=0;l<4;++l)
			 {
			  msg0[1+l]=uic0.c0[l];	
			  f++;
			 }				 
	        /*------ USB bZ[W̑M -----*/ 
	        l=0;
	        while(1){
	           if( CDC_start_snd(f,msg0) == 0) break;
	           if(l>0x100000) { break; } else{ ++l; }
			}          
	 
	 }
 
	 
	 
        // t^ɂƂƂĂLED 
		PORT.PCDR0.BYTE.H |= 0x01u;
		///////////////////////////////////////
		  		 
         if (LineCodingItem[4] == 2 )
		 {
		    // ͏ԂɉĂ̏
			// FLED@_
			PORT.PGDR0.BYTE.H &= 0xBFu;				
			kaiser_fft_flag0=1;
		 }
		 else
		 {
			// FLED@			
			PORT.PGDR0.BYTE.H |= 0x40u;			
			kaiser_fft_flag0=0;		 			 
		 }
		 
    	if( kaiser_fft_flag0 == 1)
    	{
			in0=(short *)Data0[BuffIdx_bulkin];
			// FLED@_			
			PORT.PGDR0.BYTE.H &= 0xBFu;			
			for(l=0;l<NUM_LOOP;++l)
			{		
	          f_fft_overlap_add2(in0, 1);
			  in0 += klen0; // klen0=klen0_half*2
			}
			
			// FLED@			
			PORT.PGDR0.BYTE.H |= 0x40u;				
			kaiser_fft_flag0=0;							
		
		}		
	
	// ̓ǂݍ݂	
	} // A
 }//@

}

/* DMA1 p@SSI2@ւ̑M荞ݏ@*/
void io_int_dma1(void)
{
     volatile unsigned long dummy;	 
	 
	  /* DMA ][hݒ */
      DMAC.RSAR1.LONG= (unsigned long)Data0[BuffIdx0]; /* ---- DMA [h\[XAhXWX^̐ݒ ---- */    
      DMAC.RDMATCR1.LONG= SSI_DATASIZE2 ;

	  /*---- USB bulkin Data0[] index ----*/
	  BuffIdx_bulkin=BuffIdx0;	 

	  /* ---- Mobt@̃CfbNXXV ---- */
      BuffIdx0 ^= 1u;
	 
	  
	  
	  /*--- PBDR1ݒ PB21High ---*/
	  /* LED@ */
      PORT.PBDR1.BYTE.L |= 0x20u;
	
	 
	 	 
     /* ---- gXt@GhtONA ---- */
     DMAC.CHCR1.BIT.TE = 0u;
      dummy = DMAC.CHCR1.BIT.TE; /* _~[[h */
}


#ifdef SSI3_INPUT
/* DMA2 p@SSI3@̎M荞ݏ@*/
void io_int_dma2(void)
{
     volatile unsigned long dummy;	 
	 
	  /* DMA ][hݒ */
      DMAC.RDAR2.LONG= (unsigned long)Data0[BuffIdx1]; /* ---- DMA [hfXeBl[VAhXWX^̐ݒ ---- */    
      DMAC.RDMATCR2.LONG= SSI_DATASIZE2 ;
	  
	  /* ---- Mobt@̃CfbNXXV ---- */
      BuffIdx1 ^= 1u;
	 	 
	  /*--- PBDR1ݒ PB21Low ---*/
	  /* LED@ */
      PORT.PBDR1.BYTE.L &= 0xDFu;	 
	  	 
		 
     /* ---- gXt@GhtONA ---- */
     DMAC.CHCR2.BIT.TE = 0u;
      dummy = DMAC.CHCR2.BIT.TE; /* _~[[h */
}
#endif


#define FREQ0 1000
#define SIN_F0_FS   0.141994318 
#define COS_F0_FS   0.989867472


void set_data0(void)
{
   unsigned long i,ix0;
   double y0,y1,y2;
  
   
   
   for(i=0;i<SSI_DATASIZE2;++i)
   {
#ifdef INIT_SIN_1KHZ	   
	   if(i==0 )
	   {
	      y0=0.;
		  y1=0.;	   
	   }
	   else if(i==1)
	   {
		  y0= SIN_F0_FS;
		  y2=y1;
		  y1=y0;
		     
	   }
	   else
	   {
	      y0= 2.0 * COS_F0_FS * y1 - y2;
		  y2=y1;
		  y1=y0;
	   }
	   y0=y0*32767.;
	   ix0=(int)y0;
#else
       ix0=0x0000u;
#endif	   
	   Data0[0][i]=ix0<<16;
	   Data0[0][i]+=ix0;
	   Data0[1][i]=0; //Data0[0][i];
   }
      
   //y0=sin(0.1);

}

/****************************************************************************/  
//-----------------------------------------------------------------------------------------
int f_fft_overlap_add2(short *in0, int count0)
{
   int n,nh,i,i1,i2,x1,x2,offset;
   double *ws,*datas,a0,a1;
   short *in0p;


   /*@16BIT MDOBLUE֕ϊ */


 if( count0 >= 0)
 {
   datas=works;   
   

   memcpy((char *) datas, (char *) works_half,  klen0 * sizeof(double) );

   
   in0p=in0;
   datas=works+klen0;  



   for(i=klen0_half;i<klen0;++i)
   {   
        *datas   = (double) *in0p;
        ++datas;
        ++in0p;
        *datas   = (double) *in0p;
        ++datas;
        ++in0p;
   }


   // ̂߂Ƀf[^ޔ

    datas=works;
    memcpy((char *) works_half, ((char *)datas + klen0 * sizeof(double)) , klen0 * sizeof(double));
 
  } //if( count0 >= 0)
  else
  // FIR ̉FFTvZB
  {
    datas=kaiser_lpf2;
  }
 
 
   
   /* ϊ */
   /* start fft */
   nh=klen0_half;
   n=1;
   ws=mk;
   for(i1=0;i1<nzyoux;++i1)
   {


         for(i2=0;i2<n;++i2)     // f_fttsub()2@vZĂ̂Ł@1ȂB
         {
            
            offset=2 * nh*i2;   // nh@Xebvi2Ԗ
            for(i=0;i<nh;++i)
            {
               x1=2*(i+offset);
               x2=2*(i+nh+offset);
               a0= datas[x1] - datas[x2];
               a1= datas[x1+1] - datas[x2+1];
               datas[x1]   = datas[x1] + datas[x2];
               datas[x1+1] = datas[x1+1] + datas[x2+1];

               // 2vZĂ
               datas[x2]   = a0 * ws[2*i*n]   - a1 * ws[2*i*n+1];
               datas[x2+1] = a0 * ws[2*i*n+1] + a1 * ws[2*i*n];
             }
         }
         nh=nh>>1;  //nh=nh/2;
         n=n<<1;    //n=n*2;
   }

  /* ϊ݂̂̏ꍇ */ 
  if( count0 < 0) return(999);  


   /* g̈ŏZ */
  for(i=0;i<klen0;++i)
  {
     a0= datas[2*i];
      datas[2*i]   = datas[2*i] * kaiser_lpf2[2*i] - datas[2*i+1] * kaiser_lpf2[2*i+1];
     datas[2*i+1] = datas[2*i+1] * kaiser_lpf2[2*i] + a0 * kaiser_lpf2[2*i+1];
  }


  /* tϊ */
  /* start fft */

  // wk ̋𕄍tɂĂB

  nh=1;
  n=klen0_half;
  for(i1=0;i1<nzyoux;++i1)
  {
         for(i2=0;i2<n;++i2)
         {
            
            offset=2*nh*i2;
            for(i=0;i<nh;++i)
            {
               x1=2*(i+offset);
               x2=2*(i+nh+offset);
               a0   = datas[x2] * ws[2*i*n]   + datas[x2+1] * ws[2*i*n+1];
               a1 = - datas[x2] * ws[2*i*n+1] + datas[x2+1] * ws[2*i*n];
               datas[x2]   = datas[x1] - a0;
               datas[x2+1] =  datas[x1+1] - a1;
               datas[x1]   = datas[x1] + a0;
               datas[x1+1] = datas[x1+1] + a1;
            }

         }
         n=n>>1;    //n=n/2;
         nh=nh<<1;  //nh=nh * 2;
    }


   /*  1/N  */

   in0p=in0;
   datas= works+klen0;
     
   for(i=(klen0_half);i<klen0;++i)   // Ô͎Ă
   {
        // a0 = datas[2*i];
        a0= *datas;
        if(a0 >=0)
        {
             if(a0 > 32767.) a0=32767.;
             *in0p= (short)(a0 + 0.5);   // 45
        }
        else
        {
             if(a0 < -32768.) a0=-32768.;
             *in0p= (short)(a0 - 0.5);  // 45
        }
        ++datas;
        ++in0p;
        // a0 = datas[2*i+1];
        a0= *datas;
        if(a0 >=0)
        {
             if(a0 > 32767.) a0=32767.;
             *in0p= (short)(a0 + 0.5);   // 45
        }
        else
        {
             if(a0 < -32768.) a0=-32768.;
             *in0p= (short)(a0 - 0.5);  // 45
        }
        ++datas;
        ++in0p;
   }


   return(0);

}
//------------------------------------------------------
double bessel0(double x0)
// xbZ֐̌vZ
{
#define NUM0 40

  int i;
  double y0,r0,u2,u20,y1;

  y0=1.;
  r0=1.;
  u20=x0/2.0;
  u2=u20;
  y1=u2 / r0;
  y1=y1 * y1;
  y0=y0+y1;

  for(i=2;i<NUM0;++i)
  {
      r0=r0 * (double)i;
      u2=u2*u20;
      y1=u2 / r0;
      y1=y1 * y1;
      y0=y0 + y1;
  }
  return y0;
}
//--------------------------------------------------------------------
void init_kaiserlpf_fft()
{
    short idummy[2];
    int i;
    double x0,b0,c0,*p;
   

    b0=bessel0(alfa0);
    b0=b0 * (double)klen0;
    for(i=0;i<com_order2;++i)
    { 
      x0 = M_PI * (double)(com_order2 - i) * wc0;
      if( x0 == 0.) x0 =1.0;
      else x0 = sin( x0)/ x0;
      x0= x0 * wc0;
      c0=(double)(com_order2-i) / (double)(com_order2);
      c0=1. - c0*c0;
      c0=sqrt(c0) * alfa0;
      c0=bessel0(c0);
      c0=c0/b0;
      x0= x0 * c0;
      kaiser_lpf2[2*i]=x0;
      kaiser_lpf2[2*(com_order-1-i)]=x0;
    }
    kaiser_lpf2[2*com_order2]=wc0/(double)klen0;;
    
    for(i=com_order;i<klen0;++i)
    {
       kaiser_lpf2[2*i]=0.;
    }

    p=mk;
    for(i=0;i<klen0;++i) 
    {
       kaiser_lpf2[2*i+1]=0.;
       x0= M_PI * 2.0 *(double)i / (double)klen0;
       *p= cos(x0);
       ++p;
       *p= -sin(x0);
       ++p;
    }

    f_fft_overlap_add2(idummy, -1);
	
	
	// f[^ƂėĂB
	for(i=0;i<klen0_half;++i)
	{
	   works_half[2*i]=0.;
	   works_half[2*i+1]=0.;
	}

}
//-----------------------------------------------------------------------------------------

/* End of File */
