/******************************************************************************
* DISCLAIMER

* This software is supplied by Renesas Technology Corp. and is only 
* intended for use with Renesas products. No other uses are authorized.

* This software is owned by Renesas Technology Corp. and is protected under 
* all applicable laws, including copyright laws.

* THIS SOFTWARE IS PROVIDED "AS IS" AND RENESAS MAKES NO WARRANTIES 
* REGARDING THIS SOFTWARE, WHETHER EXPRESS, IMPLIED OR STATUTORY, 
* INCLUDING BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, FITNESS FOR A 
* PARTICULAR PURPOSE AND NON-INFRINGEMENT.  ALL SUCH WARRANTIES ARE EXPRESSLY 
* DISCLAIMED.

* TO THE MAXIMUM EXTENT PERMITTED NOT PROHIBITED BY LAW, NEITHER RENESAS 
* TECHNOLOGY CORP. NOR ANY OF ITS AFFILIATED COMPANIES SHALL BE LIABLE 
* FOR ANY DIRECT, INDIRECT, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES 
* FOR ANY REASON RELATED TO THE THIS SOFTWARE, EVEN IF RENESAS OR ITS 
* AFFILIATES HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.

* Renesas reserves the right, without notice, to make changes to this 
* software and to discontinue the availability of this software.  
* By using this software, you agree to the additional terms and 
* conditions found by accessing the following link:
* http://www.renesas.com/disclaimer
********************************************************************************
* Copyright (C) 2009. Renesas Technology Corp., All Rights Reserved.           *
********************************************************************************/

/*""FILE COMMENT""*********** Technical reference data *************************
 *
 *       System Name : SH7264 USB FUNCTION Sample Program
 *       File Name   : main.c
 *       Abstract    : Sample Program Main
 *       Version     : 1.03.00
 *       Device      : SH7264/SH7262
 *       Tool-Chain  : High-performance Embedded Workshop (Ver.4.04.01).
 *                   : C/C++ compiler package for the SuperH RISC engine family
 *                   :                             (Ver.9.02 Release00).
 *       OS          : None
 *       H/W Platform: M3A-HS64G50(CPU board)
 *
 *       History   : May.13.2009 ver.1.00.00
 *                 : Jul.06.2009 ver.1.01.00 Changed common directory
 *                 : Jul.13.2009 ver.1.02.00 Tool-Chain 9.2.0.0
 *                 : Nov.10.2009 ver.1.03.00 Changed common directory
 *""FILE COMMENT END""**********************************************************/
#include <stdio.h>
#include <string.h>
#include <machine.h>
#include <mathf.h>
#include "iodefine.h"       /* SH7264 iodefine  */
#include "m3a_hs64.h"
#include "usb.h"
#include "usb_firm.h"
#include "common.h"


/* ---- MMf[^ 2ʂ݂ɓւċpp---- */
//  V3ʂ4{̃f[^荞݂ƂĎg
#pragma section CDATA
unsigned long Data0[3][(SSI_DATASIZE + BUF_SIZE_USB0)/4];  
#pragma section


unsigned int BuffIdx0,BuffIdx1;   // Data0[BuffIdx][]
unsigned int BuffIdx_bulkin;
unsigned int BuffIdx_bulkin_old;


/*----- bulkout message ------*/
unsigned char message_bulkout[4][2];

#ifdef KAISERLPF_FFT  
// Float(SINGLE)ŁF@@DOUBLEi{xjɂƌvZԂ񂺂s(3`4{)ĉȂ̂łނȂPxɂB
//
//                  sXebv̔r
//   FMUL FRxFR->FR   1
//   FMUL DRxDR->DR   6
//   
//   FSUB FR-FR->FR   1
//   FSUB DR-DR->DR   6
//
/*------ kaiser fir fft ------*/
#define M_PI 3.14159265358979F
#define klen0      256  //512 
#define klen0_half  128  //256
#define klen0_half_half 64
#define klen0x2    512
#define nzyoux  8
#define FFT_STEP0 4  // 4{Xebv`
#define FFT_STEP2 7  // FFT_STEP0 * 2 -1
//
// FIRtB^[̓
//@@110dB
#define DB0 110.0F
// @   0.111/4
// fc=1/8fs Őݒ肷邱ƂOƂĂBɂA͂߂̑g͓̓f[^ƓlɂȂAvZȗłB
#define FC0 0.125F
// FIR tB^[̉FFT̂@FFT_STEP0 -1(4-1=3)̑gɂȂB
#define FFT_FIL0  1  // [vJn̏Ԃ` 
// f_fft_overlap_add2bĂяo񐔁@
#define NUM_LOOP  128 //(SSI_DATASIZE2 / FFT_STEP0) / klen0_half 

int    kaiser_fft_flag0;

float mk[klen0 * 2];   //2k
float works[klen0 * 2];  // Ɨ̈       //2k  
float works2[klen0 * 2]; // S{pɐVɃf[^ޔ̈  //2k 
float kaiser_lpf1[klen0 * 2 ];   // FIR tB^[̉FFT̂i[ĂBPgB@//2k
float kaiser_lpf2[klen0 * 2 ];   // FIR tB^[̉FFT̂i[ĂBQgB@//2k 
float kaiser_lpf3[klen0 * 2 ];   // FIR tB^[̉FFT̂i[ĂBRgB@//2k 
float works_half[klen0_half * 2];   //1k 
unsigned long   lworks_klen0[klen0_half_half]; //0.25k 

#endif // #ifdef KAISERLPF_FFT  


//***********************************
// fobOpPCɃf[^𑗂邽߂̃IvVB
////#define DEBUG6 1
#ifdef  DEBUG6 
union {
	float f0;
	char   c0[4];
} ufc0;

union {
	short  s0;
	char   c0[2];
} usc0;

int not_init_zero;
#endif

union {
	int i0;
	char   c0[4];
} uic0;

#ifdef  DEBUG6 
unsigned char msg0[257];
#else
unsigned char msg0[65];
#endif


/* {TvOĐtO */
int double_speed0;

/* ==== vg^Cv錾 ==== */
void init_ssif(void);
void change_ssi2_bck();
void io_init_dma1(void *src, void *rsrc, void *dst, void *src2, void *dst2, void *rdst2);
void set_data0(void);
void init2_kaiserlpf_fft(void);
int f_fft_overlap_add2b(short *in0, short *out0, int count0);
void map_step_4(unsigned long *in1, unsigned long *out0, int delay0);

#define BULK_OUT_PIPE	PIPE1
#define BULK_IN_PIPE	PIPE2
#define INTR_IN_PIPE	PIPE6


extern int CDC_start_snd( unsigned long size, unsigned char *top );
extern int CDC_start_rcv( unsigned long size, unsigned char *buf );
extern int CDC_check_complete( unsigned short Pipe );
extern void CDC_snd_char(unsigned char c);

extern unsigned char		LineCodingItem[];
// /*	Line Coding Structure	*/
// unsigned char		LineCodingItem[] = {
//	0x00,0xC2,0x01,0x00,	/*	0-3	dwDTERate 	Bit Rate(bps)	Default : 0x1C200 (115200)	*/
//	0x00,					/*	 4	bCharFormat Stop BIt		Default : 0 (1 Stop bit)	*/
//	0x00,					/*	 5	bCharFormat Parity			Default : 0 (None )			*/
//	0x08,					/*	 6	bCharFormat Data Bit		Default : 8					*/
//	0x00					/*	 7	bCharFormat Flow Control	Default : 0 (SW or None)	*/
//};



/*""FUNC COMMENT""*******************************************************
 * Outline     : main
 *-----------------------------------------------------------------------
 * Include     : 
 *-----------------------------------------------------------------------
 * Declaration : void main(void);
 *-----------------------------------------------------------------------
 * Description : 
 *-----------------------------------------------------------------------
 * Argument    : void
 *-----------------------------------------------------------------------
 * Return Value: void
 *-----------------------------------------------------------------------
 * Notice      : 
 *""FUNC COMMENT END""***************************************************/
 

void main(void)
{	
	int i, f, l;
    unsigned long l_SSI_DATASIZE;
	unsigned char c, *p;
	int count0,size0,count2;
    unsigned long *in1, *out1;
      


        /* PB21 ɒǉLED̐̂߂̏ݒ */
		/* ƕt^ɂƂƂĂLED̐̂߂̏ */
		/* PG14ɒǉLED̐̂߂̏ݒ  */
	    /*--- PBCR5ݒ PB21̐ݒ ---*/	
	    PORT.PBCR5.WORD &= 0xFF0Fu;
		PORT.PCCR2.WORD &= 0xFFF0u;
#ifdef YLED0
		PORT.PGCR3.WORD &= 0xF0FFu;
#endif
    	/*--- PBIOR1ݒ PB21LEDo͂ɐݒ ---*/
	    PORT.PBIOR1.WORD |= 0x0020u;
		PORT.PCIOR0.WORD |= 0x0100u;
#ifdef YLED0
		PORT.PGIOR0.WORD |= 0x4000u;
#endif	
     	/*--- PBDR1ݒ PB21Low ---*/
     	PORT.PBDR1.BYTE.L &= 0xDFu;
		PORT.PCDR0.BYTE.H &= 0xFEu;
#ifdef YLED0
		PORT.PGDR0.BYTE.H &= 0xBFu;
		// FLED@	
		PORT.PGDR0.BYTE.H |= 0x40u;	
#endif


                /* 2{TvOĐǂ */
		 double_speed0=0;
		 	  
    	/* f[^̏  */
		set_data0();

       
       /*-- DMAC ̏ݒ ---- */
	  /*  SSI2M   SSI3M   */
	   BuffIdx0 = 0u;	   
       BuffIdx1 = 1u;  
       io_init_dma1( Data0[0], Data0[1], (void *)&SSIF2.SSIFTDR,(void *)&SSIF3.SSIFRDR, Data0[1], Data0[0]);
       
	   /*-- SSI ̏ݒ ---- */ 
       init_ssif();	   
	   
	   


	   
	  /*-- USB bulkout ̃bZ[W --*/
	   message_bulkout[0][0]=0x30;
	   message_bulkout[1][0]=0x31;   		
	

#ifdef  KAISERLPF_FFT      
	  kaiser_fft_flag0=0;
	  init2_kaiserlpf_fft();
#endif	
	
	
	P_ModeInit();

#ifndef USB_ONLY0
        io_init_scif2();
#endif

#ifdef DEBUG6
       not_init_zero=0;
#endif   
   
re_start0:
                         
   			// FLED@
#ifdef YLED0			
			PORT.PGDR0.BYTE.H |= 0x40u;	
#endif			
			kaiser_fft_flag0=0;
                        count2=0;
                        l_SSI_DATASIZE = SSI_DATASIZE;

   // HOST@PC̋NMiXgbvrbgPȏj҂B
   while(1){
	 
	 if(LineCodingItem[4] == 12)
     {
       double_speed0=2;
       change_ssi2_bck();
	   break;
     }
     else if(LineCodingItem[4] == 14)
     {
       double_speed0=4;
       change_ssi2_bck();
	   break;
     }
     else if(LineCodingItem[4] == 11)
     {
       double_speed0=1;
       change_ssi2_bck();
	   break;
     }
     else if(LineCodingItem[4] == 4)  //x4fs DF zero naisou method
     {
       double_speed0=4;
       change_ssi2_bck();
      kaiser_fft_flag0=1;
      l_SSI_DATASIZE = SSI_DATASIZE;  // 4񕪂܂Ƃ߂ēǂݍ
	   break;
     }

#ifdef DEBUG6	 
	 else if(LineCodingItem[4] == 6) // fboOpPCɃf[^𑗂B
	 {

                        f=0;
			//msg0[0]=0x66; f++;    // data type float
                        //msg0[0]=0x69; f++;    // data type int
                        msg0[0]=0x73; f++;    // data type short
			for(i=0;i<63;++i)
			{
                         // ufc0.f0= kaiser_lpf1[2 * i];
		         // ufc0.f0= works2[i];		
                         uic0.i0= Data0[0][i];		
			 for(l=0;l<4;++l)
			 {
			 // msg0[1+4*i+l]=ufc0.c0[l];	
                            msg0[1+4*i+l]=uic0.c0[l];
                            f++;
			 }
			}
				
	        //------ USB bZ[W̑M -----
	          CDC_start_snd(f,msg0);
	           
	       
       
       double_speed0=1;
       not_init_zero=1;  // 2ڂ́AData0ŏ㏑ȂB
       change_ssi2_bck();
	   break;	 

	 }	 
#endif
	  else if(LineCodingItem[4] > 0) break; 
   }


/*  BuffIdx Zbg */	
    BuffIdx_bulkin=BuffIdx0;
	BuffIdx_bulkin^= 1u;
    BuffIdx_bulkin_old=BuffIdx_bulkin;

	
/*    USB@f[^̓ǂݍ݂̌JԂ@@@*/	
while(1){  //@
	 
	//  HOST@PĆiXgbvrbgOjҋ@ցB
	if(LineCodingItem[4] == 0)
	{
#ifdef DEBUG6 
             // 6̂Ƃ, not_init_zeroPɂ́Af[^𑗂̗㏑ȂB
             if(not_init_zero ==0) set_data0();
#else
		set_data0();
#endif
		goto re_start0;
	}



	if(  BuffIdx_bulkin_old != BuffIdx_bulkin) // A
	{	
	  BuffIdx_bulkin_old=BuffIdx_bulkin;

          
          if( kaiser_fft_flag0 == 1) 
          {
               if( count2 > 0) goto direct_kaiser;
               p=(unsigned char *)Data0[2];
	  }
          else p=(unsigned char *)Data0[BuffIdx_bulkin];
	  
	  
	 //t^ɂƂƂĂLED_ 
	 PORT.PCDR0.BYTE.H &= 0xFEu;
	 //////////////////////////////////////
	 
	 /*------ USB bZ[W̑M -----*/ 
	 l=0;
	 while(1){
	  if( CDC_start_snd(1,message_bulkout[BuffIdx_bulkin]) == 0) break;
	  if(l>0x100000) { break; } else{ ++l; }
	 }	
	 /*------ bZ[W̑M܂ő҂ -----*/
	 l=0;

	 while( !(CDC_check_complete(BULK_IN_PIPE)) ){	 		 
	  if(l>0x100000) { break; } else{ ++l; }
		/* wait */
	 }	
	 
	 count0=0;	 f=0;  	 
	 while( count0 < l_SSI_DATASIZE )
	 {
	     /*------ USB f[^̎M -----*/ 
	     l=0;
	      while(1){
	      if( CDC_start_rcv(BUF_SIZE_USB0,p) == 0) break;	  
           if(l > 0x200000) { break; } else{ ++l;++f;}
	     }	
	     /*------ f[^M܂ő҂ -----*/
	     l=0;
	      while( !(CDC_check_complete(BULK_OUT_PIPE)) ){
		    if(l> 0x100000) { break; } 	else{ ++l; ++f;}
	      	/* wait */
	     }			 

		  
		 size0 = BUF_SIZE_USB0 - USBDataCount[ BULK_OUT_PIPE ];
	     count0 +=size0;
		 p += size0;
		
		 if(f > 0x200000) { break; } 
	 }
	 
	 if( count0 >= l_SSI_DATASIZE) {
	 /*--- PBDR1ݒ PB21Low ---*/
	 /* LED@ */
         PORT.PBDR1.BYTE.L &= 0xDFu;  
         count2=FFT_STEP0;   // 4{̃f[^ǂݍ񂾁B
	 }
	 else
	 {
        count2=0; 
#ifdef FIFO_DMA_OUT
               //  IɎMI点B
               /* D0FIFO DMA stop   */
               DMAC.CHCR5.BIT.DE    = 0;		/* DMA transfer disabled */
               DMAC.CHCR5.BIT.TE     = 0;		/* Transfer end flag clear */
               if( DMAC.CHCR5.BIT.TS == 0 ) {
		         PipeDataSize[BULK_OUT_PIPE] -= DMAC.DMATCR5.LONG;			/* 8bit		*/
	            }
	            else if( DMAC.CHCR5.BIT.TS == 1 ){
		         PipeDataSize[BULK_OUT_PIPE] -= (DMAC.DMATCR5.LONG * 2);			/* 16bit	*/
               }
	            else if( DMAC.CHCR5.BIT.TS == 2 ){
		         PipeDataSize[BULK_OUT_PIPE] -= (DMAC.DMATCR5.LONG * 4);			/* 32bit	*/
	           }
	           USB.D0FIFOSEL.BIT.DREQE = 0;     // DMAN֎~
               USB.D0FIFOCTR.WORD = BITBCLR;    // obt@NA[
               PipeFlag[BULK_OUT_PIPE] = PIPE_DONE;
		     
#endif


             // ۂɎMf[^zXgPC֑B 
             f=0;

		     msg0[0]=0x69; f++;   // char i
             uic0.i0=	count0;			
			 for(l=0;l<4;++l)
			 {
			  msg0[1+l]=uic0.c0[l];	
			  f++;
			 }				 
	        /*------ USB bZ[W̑M -----*/ 
	        l=0;
	        while(1){
	           if( CDC_start_snd(f,msg0) == 0) break;
	           if(l>0x100000) { break; } else{ ++l; }
			}          
	 
	 }
 
	 
	 
        // t^ɂƂƂĂLED 
		PORT.PCDR0.BYTE.H |= 0x01u;
		///////////////////////////////////////
		 
#ifdef  KAISERLPF_FFT 		 
        
direct_kaiser:	 
    	if( (kaiser_fft_flag0 == 1) && (count2 > 0))      // count2 > 0 f[^ǂݍłB
    	{
		
            in1=(Data0[2]+(SSI_DATASIZE44 * (FFT_STEP0 - count2)));
			out1=Data0[BuffIdx_bulkin];
			
			// FLED@_
#ifdef YLED0			
			PORT.PGDR0.BYTE.H &= 0xBFu;	
#endif			
             


             /* FFT_STEP0 Ɂ@Ƃ̒l̂܂ܓĂ fc=1/8fc */
             map_step_4( in1, out1, klen0_half_half);
              
       		  					
			for(l=0;l<NUM_LOOP;++l)
			{		
	          f_fft_overlap_add2b((short *) in1, (short *)out1, 1);
			  in1 += klen0_half; 
			  out1 += klen0x2;
			}
			
			// FLED@
#ifdef YLED0			
			PORT.PGDR0.BYTE.H |= 0x40u;	
#endif			
            --count2;  // P񕪂̃f[^B
	    
		    /**************************************/
					
		
		}	
#endif   // #ifdef  KAISERLPF_FFT 	
	
	// ̓ǂݍ݂	
	} // A
 }//@

}

/* DMA1 p@SSI2@ւ̑M荞ݏ@*/
void io_int_dma1(void)
{
     volatile unsigned long dummy;	 
	 
	  /* DMA ][hݒ */
      DMAC.RSAR1.LONG= (unsigned long)Data0[BuffIdx0]; /* ---- DMA [h\[XAhXWX^̐ݒ ---- */    
      DMAC.RDMATCR1.LONG= SSI_DATASIZE2 ;

	  /*---- USB bulkin Data0[] index ----*/
	  BuffIdx_bulkin=BuffIdx0;	 

	  /* ---- Mobt@̃CfbNXXV ---- */
      BuffIdx0 ^= 1u;
	 
	  
	  
	  /*--- PBDR1ݒ PB21High ---*/
	  /* LED@ */
      PORT.PBDR1.BYTE.L |= 0x20u;
	
	 
	 	 
     /* ---- gXt@GhtONA ---- */
     DMAC.CHCR1.BIT.TE = 0u;
      dummy = DMAC.CHCR1.BIT.TE; /* _~[[h */
}


#ifdef SSI3_INPUT
/* DMA2 p@SSI3@̎M荞ݏ@*/
void io_int_dma2(void)
{
     volatile unsigned long dummy;	 
	 
	  /* DMA ][hݒ */
      DMAC.RDAR2.LONG= (unsigned long)Data0[BuffIdx1]; /* ---- DMA [hfXeBl[VAhXWX^̐ݒ ---- */    
      DMAC.RDMATCR2.LONG= SSI_DATASIZE2 ;
	  
	  /* ---- Mobt@̃CfbNXXV ---- */
      BuffIdx1 ^= 1u;
	 	 
	  /*--- PBDR1ݒ PB21Low ---*/
	  /* LED@ */
      PORT.PBDR1.BYTE.L &= 0xDFu;	 
	  	 
		 
     /* ---- gXt@GhtONA ---- */
     DMAC.CHCR2.BIT.TE = 0u;
      dummy = DMAC.CHCR2.BIT.TE; /* _~[[h */
}
#endif


#define FREQ0 1000
#define SIN_F0_FS   0.141994318 
#define COS_F0_FS   0.989867472


void set_data0(void)
{
   unsigned long i,ix0;
   float y0,y1,y2;
  
   
   
   for(i=0;i<SSI_DATASIZE2;++i)
   {
#ifdef INIT_SIN_1KHZ	   
	   if(i==0 )
	   {
	      y0=0.;
		  y1=0.;	   
	   }
	   else if(i==1)
	   {
		  y0= SIN_F0_FS;
		  y2=y1;
		  y1=y0;
		     
	   }
	   else
	   {
	      y0= 2.0 * COS_F0_FS * y1 - y2;
		  y2=y1;
		  y1=y0;
	   }
	   y0=y0*32767.;
	   ix0=(int)y0;
#else
       ix0=0x0000u;
#endif	   
	   Data0[0][i]=ix0<<16;
	   Data0[0][i]+=ix0;
	   Data0[1][i]=0; //Data0[0][i];
   }
      
   //y0=sin(0.1);

}

/****************************************************************************/
#ifdef KAISERLPF_FFT  
//-----------------------------------------------------------------------------------------
int f_fft_overlap_add2b(short *in0, short *out0, int count0)
{
   int n,nh,i,i1,i2,x1,x2,x3,offset,loop;
   float *ws,*datas,*klp,a0,a1;
   short *in0p;


   /*@16BIT MDOBLUE֕ϊ */


 if( count0 >= 0)
 {
   datas=works;   
   

   memcpy((char *) datas, (char *) works_half,  klen0 * sizeof(float) );

   
   in0p=in0;
   datas=works+klen0;  



   for(i=klen0_half;i<klen0;++i)
   {   
        *datas   = (float) *in0p;
        ++datas;
        ++in0p;
        *datas   = (float) *in0p;
        ++datas;
        ++in0p;
   }


   // ̂߂Ƀf[^ޔ

    datas=works;
    memcpy((char *) works_half, ((char *)datas + klen0 * sizeof(float)) , klen0 * sizeof(float));
 
  } //if( count0 >= 0)
  else
  // FIR ̉FFTvZB
  {
    if( count0 == -1) datas=kaiser_lpf1;
    else if( count0 == -2 ) datas=kaiser_lpf2;
    else  datas=kaiser_lpf3;  // when count0==-3
  }
 
 
   
   /* ϊ */
   /* start fft */
   nh=klen0_half;
   n=1;
   ws=mk;
   for(i1=0;i1<nzyoux;++i1)
   {


         for(i2=0;i2<n;++i2)     // f_fttsub()2@vZĂ̂Ł@1ȂB
         {
            
            offset=2 * nh*i2;   // nh@Xebvi2Ԗ
            for(i=0;i<nh;++i)
            {
               x1=2*(i+offset);
               x2=2*(i+nh+offset);
               a0= datas[x1] - datas[x2];
               a1= datas[x1+1] - datas[x2+1];
               datas[x1]   = datas[x1] + datas[x2];
               datas[x1+1] = datas[x1+1] + datas[x2+1];

               // 2vZĂ
               x3=2*i*n;

               datas[x2]   = a0 * ws[x3]   - a1 * ws[x3+1];
               datas[x2+1] = a0 * ws[x3+1] + a1 * ws[x3];

             }
         }
         nh=nh>>1;  //nh=nh/2;
         n=n<<1;    //n=n*2;
   }

  /* ϊ݂̂̏ꍇ */ 
  if( count0 < 0) return(999);  

   /* ̂߂Ƀf[^ޔ   */
    datas=works;
    memcpy((char *) works2, (char *)datas , 2 * klen0 * sizeof(float));
 

   /* FFT_FIL0 FFT_STEP0܂ŉ@vZ */
  for(loop=FFT_FIL0;loop<FFT_STEP0; ++loop)
  { 
   
   /* ޔf[^Ăяo */
    if( loop != FFT_FIL0) 
    {
     datas=works;
     memcpy((char *) datas, (char *)works2 , 2 * klen0 * sizeof(float));
    }
   
   /* FIR tB^[̉FFT̂Ăяo */
   if( loop == 1) klp=kaiser_lpf1;
   else if( loop == 2 ) klp=kaiser_lpf2;
   else  klp=kaiser_lpf3;  // when loop==-3

  /* g̈ŏZ */

  x1=0; x2=1;
  for(i=0;i<klen0;++i)
  {
     a0= datas[x1];
      datas[x1]   = datas[x1] * klp[x1] - datas[x2] * klp[x2];
     datas[x2] = datas[x2] * klp[x1] + a0 * klp[x2];
     x1+=2;
     x2+=2;
  }

  /* tϊ */
  /* start fft */

  // wk ̋𕄍tɂĂB

  nh=1;
  n=klen0_half;
  for(i1=0;i1<nzyoux;++i1)
  {
         for(i2=0;i2<n;++i2)
         {
            
            offset=2*nh*i2;
            for(i=0;i<nh;++i)
            {
               x1=2*(i+offset);
               x2=2*(i+nh+offset);

               x3=2*i*n;

               a0   = datas[x2] * ws[x3]   + datas[x2+1] * ws[x3+1];
               a1 = - datas[x2] * ws[x3+1] + datas[x2+1] * ws[x3];
               datas[x2]   = datas[x1] - a0;
               datas[x2+1] =  datas[x1+1] - a1;
               datas[x1]   = datas[x1] + a0;
               datas[x1+1] = datas[x1+1] + a1;
            }

         }
         n=n>>1;    //n=n/2;
         nh=nh<<1;  //nh=nh * 2;
    }


   /*  1/N  */

   in0p=(out0 + 2 * loop);
   datas= works+klen0;
     
   for(i=(klen0_half);i<klen0;++i)   // Ô͎Ă
   {
        // a0 = datas[2*i];
        a0= *datas;
        if(a0 >=0)
        {
             if(a0 > 32767.) a0=32767.;
             *in0p= (short)(a0 + 0.5);   // 45
        }
        else
        {
             if(a0 < -32768.) a0=-32768.;
             *in0p= (short)(a0 - 0.5);  // 45
        }
        ++datas;
        ++in0p;
        // a0 = datas[2*i+1];
        a0= *datas;
        if(a0 >=0)
        {
             if(a0 > 32767.) a0=32767.;
             *in0p= (short)(a0 + 0.5);   // 45
        }
        else
        {
             if(a0 < -32768.) a0=-32768.;
             *in0p= (short)(a0 - 0.5);  // 45
        }
        ++datas;
        in0p +=FFT_STEP2 ;
   }
   }/* ܂FFT_FIL0 FFT_STEP0܂ŉ@vZ */
     
  

   return(0);

}
//------------------------------------------------------
float bessel0(float x0)
{
#define NUM0 40

  int i;
  float y0,r0,u2,u20,y1;

  y0=1.;
  r0=1.;
  u20=x0/2.0;
  u2=u20;
  y1=u2 / r0;
  y1=y1 * y1;
  y0=y0+y1;

  for(i=2;i<NUM0;++i)
  {
      r0=r0 * (float)i;
      u2=u2*u20;
      y1=u2 / r0;
      y1=y1 * y1;
      y0=y0 + y1;
  }
  return y0;
}
//--------------------------------------------------------------------
void map_step_4(unsigned long *in1, unsigned long *out0, int delay0)
{
   int i;
   
   for(i=0;i<SSI_DATASIZE44;++i)
   {    
    if(i < delay0)  *out0= lworks_klen0[i];
    else *out0 = in1[i - delay0];
    out0 +=FFT_STEP0;
   }
   for(i=0;i<delay0;++i) lworks_klen0[i]= in1[ SSI_DATASIZE44 - delay0 +i ];

}
//--------------------------------------------------------------------
void init2_kaiserlpf_fft()
{
    short idummy[2];
    int i,j;
    float alfa0,x0,b0,c0,*p;


      // f[^ƂėĂB
     for(i=0;i<klen0;++i)
     {
	    if(i<klen0_half)
        {
          works_half[2*i]=0.;
	      works_half[2*i+1]=0.;
        }
		
        kaiser_lpf1[2*i]=0.;
        kaiser_lpf1[2*i+1]=0.;
        kaiser_lpf2[2*i]=0.;
        kaiser_lpf2[2*i+1]=0.;
        kaiser_lpf3[2*i]=0.;
        kaiser_lpf3[2*i+1]=0.;

        if(i<klen0_half_half)  lworks_klen0[i]=0;
     }

     


   /* kaiser ̌vZ */
    alfa0= 0.1102 * (DB0 - 8.7);
    b0=bessel0( alfa0);


    // FFT̋tϊ̂m̂PƁ@}邱ƂɂUȂ镪i1/FFT_STEP0)␳
    b0=b0 * (float)klen0 / (float)FFT_STEP0;
    
    j=0;  // set counter 0
    for(i=0;i<klen0;++i)
    { 
      x0 = 2. * M_PI * FC0 * (float)(klen0-i);
      x0 = sinf( x0);
      x0= x0 / ( M_PI * (float)(klen0 -i));

      c0=(float)(klen0 - i) / (float)(klen0);
      c0=1. - c0*c0;
      c0=sqrtf(c0) * alfa0;   // float sqrtfłB
      c0=bessel0(c0);
      c0=c0/b0;

      x0= x0 * c0;

      switch( i% FFT_STEP0 )
      {
        case 1:
           kaiser_lpf1[2*j]=x0;
           kaiser_lpf3[2*(klen0_half -1-j)]=x0;
           break;
        case 2:
           kaiser_lpf2[2*j]=x0;
           kaiser_lpf2[2*(klen0_half -1-j)]=x0;
           break;
        case 3:
           kaiser_lpf3[2*j]=x0;
           kaiser_lpf1[2*(klen0_half -1-j)]=x0;
           ++j;
           break;
          default: 
          break;
      }

    }
    

    /* sin cos table  */
    p=mk;
    for(i=0;i<klen0;++i) 
    {
      
       x0= M_PI * 2.0 *(double)i / (double)klen0;
       *p= cosf(x0);
       ++p;
       *p= -sinf(x0);
       ++p;
    }

     /* 炩FIRtB^[FFTvZĂB@*/
     f_fft_overlap_add2b(idummy, idummy, -1);
     f_fft_overlap_add2b(idummy, idummy, -2);
     f_fft_overlap_add2b(idummy, idummy, -3);


	 
	
}
//-----------------------------------------------------------------------------------------
#endif

/* End of File */
