/******************************************************************************
* DISCLAIMER

* This software is supplied by Renesas Technology Corp. and is only 
* intended for use with Renesas products. No other uses are authorized.

* This software is owned by Renesas Technology Corp. and is protected under 
* all applicable laws, including copyright laws.

* THIS SOFTWARE IS PROVIDED "AS IS" AND RENESAS MAKES NO WARRANTIES 
* REGARDING THIS SOFTWARE, WHETHER EXPRESS, IMPLIED OR STATUTORY, 
* INCLUDING BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, FITNESS FOR A 
* PARTICULAR PURPOSE AND NON-INFRINGEMENT.  ALL SUCH WARRANTIES ARE EXPRESSLY 
* DISCLAIMED.

* TO THE MAXIMUM EXTENT PERMITTED NOT PROHIBITED BY LAW, NEITHER RENESAS 
* TECHNOLOGY CORP. NOR ANY OF ITS AFFILIATED COMPANIES SHALL BE LIABLE 
* FOR ANY DIRECT, INDIRECT, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES 
* FOR ANY REASON RELATED TO THE THIS SOFTWARE, EVEN IF RENESAS OR ITS 
* AFFILIATES HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.

* Renesas reserves the right, without notice, to make changes to this 
* software and to discontinue the availability of this software.  
* By using this software, you agree to the additional terms and 
* conditions found by accessing the following link:
* http://www.renesas.com/disclaimer
********************************************************************************
* Copyright (C) 2009. Renesas Technology Corp., All Rights Reserved.           *
********************************************************************************/

#include "../../common.h"


/*""FILE COMMENT""*********** Technical reference data *************************
 *
 *       System Name : SH7264 USB FUNCTION Sample Program
 *       File Name   : p_main.c
 *       Abstract    : Peripheral Sample Program Main
 *       Version     : 1.01.00
 *       Device      : SH7264/SH7262
 *       Tool-Chain  : High-performance Embedded Workshop (Ver.4.04.01).
 *                   : C/C++ compiler package for the SuperH RISC engine family
 *                   :                             (Ver.9.02 Release00).
 *       OS          : None
 *       H/W Platform: M3A-HS64G50(CPU board)
 *
 *       History     : May.13,2009 ver.1.00.00
 *                   : Dec.25,2009 ver.1.01.00 CDCΉ
 *""FILE COMMENT END""**********************************************************/
#include <machine.h>
#include <stdio.h>
#include "usb.h"

/* ==== }N` ==== */
#define BULK_OUT_PIPE	PIPE1
#define BULK_IN_PIPE	PIPE2
#define RCV_BUFSIZE		512

#ifdef USE_INTR 
#define  INTR_IN_PIPE  PIPE6
#endif


/* ==== vg^Cv錾 ==== */
void Restart(void *, void *);  /* VKǉ */

void Console_Putch(unsigned char c); /* VKǉ */
void Console_Puts(unsigned char *p); /* VKǉ */
int Console_RecvCheck(void);         /* VKǉ */
unsigned char Console_Getch(void);   /* VKǉ */
int Console_Gets(unsigned char *p);  /* VKǉ */

void P_Main(void);
void CDC_snd_char(unsigned char c);
int CDC_rcv_buffercheck(void);  /* VKǉ */
unsigned char CDC_rcv_char(void);
int CDC_start_snd( unsigned long size, unsigned char *top );
int CDC_start_rcv( unsigned long size, unsigned char *buf );
int CDC_check_complete( unsigned short Pipe );


/* Mobt@ i[oCgێϐ(O[oϐ) */
static int rsz = 0;
static unsigned char buf[RCV_BUFSIZE];
static int idx = 0;
static int recvcheck = 0;	/* M`FbNXe[gϐ(VKǉ) */


/*******************************************/
/* R\[o͏[` (VKǉ) */
/*******************************************/

/* R\[o(VKǉ) */
void Console_Putch(unsigned char c)
{
	/* USBzVAڑ */
	if( P_IsConfigured() == USB_YES ){	/* check device state	*/
		CDC_snd_char( c );	/* USB CDC */
	}
	io_putchar( c );	/* SCIF2 */
}

/* R\[o(VKǉ) */
void Console_Puts(unsigned char *p)
{
	unsigned char c;
	while( *p != 0) {
		c = *p++;
		if ( c == 0x0A ) {
			Console_Putch( 0x0D );
			Console_Putch( 0x0A );
		} else {
			Console_Putch( c );
		}
	}
}

/* R\[̓`FbN(VKǉ) */
int Console_RecvCheck(void)
{
	/* USBzVAڑ */
	if( P_IsConfigured() == USB_YES ){		/* check device state	*/
		/* USBzVA Mf[^H */
		if (CDC_rcv_buffercheck()) return -1;
	}
	if (io_recvcheck()) return -1;
	return 0;
}

/* R\[(VKǉ) */
unsigned char Console_Getch(void)
{
	unsigned char c;
	while(1){
		/* USBzVAڑ */
		if( P_IsConfigured() == USB_YES ){		/* check device state	*/
			/* USBzVA Mf[^H */
			if (CDC_rcv_buffercheck()) {
				c = CDC_rcv_char();
				break;
			}
		}
#ifndef USB_ONLY0
		/* SCIF2 Mf[^H */
		if (io_recvcheck()) {
			c = io_getchar();
			break;
		}
#endif
	}
	return c;
}

/* R\[(CRR[h܂/ő255/GR[obN)(VKǉ) */
int Console_Gets(unsigned char *p)
{
	unsigned char c;
	int i;
	i = 0;
	while(1){
		c = Console_Getch();	/* 1 */
		if (c == 0x0D) break;	/* CRR[h܂ŎM */
		Console_Putch( c );		/* 1o(GR[obN) */
		*p = c;
		p++;
		i++;
		if (i > 255) break;		/* ő啶ɒB */
	}
	*p=(unsigned char)0;		/* nullR[h */
	return i;					/* ͕ */
}


/*************************************/
/* CE[` (VK쐬)       */
/*************************************/
#ifndef USB_ONLY0
void P_Main(void)
{
	unsigned int adr, *j, jump;
	int i, f, l;
	unsigned char c, buff[256], *p;

	/* R\[o͊mF̂߂Enter͑҂ */
	while(1){
		/* R\[ */
		c = Console_Getch();
		if ( c == 0x0D ) break;
	}

	/* _E[hJnAhX */
	Console_Puts("\n\nSH7262 Serial Downloader Program\nInput download address = ");
	i = Console_Gets(buff);	/* R\[ */
	Console_Puts("\n");
	if (i == 0) adr = 0x1C000000;	/* ftHgAhX */
	else        adr = strtol(buff, NULL, 16);  /* 16iϊ */
	Console_Puts("Download address : ");
	sprintf(buff, "%08Xh\n", adr);
	Console_Puts(buff);

	/* _E[hJn */
	Console_Puts("Binaryimage download start! ");
	p=(unsigned char *)adr;
	i=f=l=0;
	while(i<0x100000) {
		/* UARTMobt@`FbN */
		if (Console_RecvCheck()) {
			c = Console_Getch();	/* 1oCgo */
			*p = c;
			p++;
			/* 1KoCg1'.'\ */
			if ((l&0xFFF)==0) Console_Puts(".");
			l++;	/* _E[hoCgJE^ */
			i = 0;	/* AChOԃJE^NA */
			f = 1;	/* _E[hJntOZbg */
		} else {
			if (f) i++;
			/* AChOԃJEg */
		}
	}
	/* SH-2A(144MHz)ŁA1b̎Ԃ󂢂_E[hƔf */

	/* _E[hbZ[W\ */
	sprintf(buff, "\nDownload program size : %08Xh\n", l);
	Console_Puts(buff);
	j=(unsigned int *)(adr);
	jump=*j;					/* ZbgxN^擾 */
	sprintf(buff, "Jump address : %08Xh\n", jump);
	Console_Puts(buff);
	Console_Puts("Download program start!!\n\n");
	for(i=0;i<0x16;i++){
		Console_Putch(0);	/* _~[o */
	}

	/* ==== Interrupt mask level change ==== */
	set_imask(0x000000F0);

	INTC.IBNR.WORD = 0x0000;	/* WX^oOfBZ[u */

	/* USBRg[fBZ[u */
	INTC.IPR10.BIT._USB = 0;	/* Set USB interrupt level */
	USB.SYSCFG.WORD = 0x0481;	/* DPRUP off */
	for(i=0;i<0x100000;i++){}	/* EFCg */
	USB.SYSCFG.WORD = 0x0401;	/* HSE off */
	for(i=0;i<0x100000;i++){}	/* EFCg */
	USB.SYSCFG.WORD = 0x0400;	/* USB off */
	for(i=0;i<0x100000;i++){}	/* EFCg */
	USB.SYSCFG.WORD = 0x0;		/* SCKE off */

	usb_reset_module();	/* USBW[ Zbg */

	/* _E[hvOɃWv(VBRX^bNĐݒ肳) */
	Restart((void *)jump, (void *)adr);
}
#endif

/*""FUNC COMMENT""************************************************************ 
* ID          : 
* Outline     : 1oCgM
*----------------------------------------------------------------------------- 
* Include     : 
*----------------------------------------------------------------------------- 
* Declaration : void CDC_snd_char(unsigned char c);
*----------------------------------------------------------------------------- 
* Description : oNIN]gpāA1oCgf[^USBzXgɑM܂B
*             : MɌĂяoɖ߂܂B
*----------------------------------------------------------------------------- 
* Argument    : unsigned char c : I ; Mf[^
*----------------------------------------------------------------------------- 
* Return Value: void
*----------------------------------------------------------------------------- 
* Notice      : 
*""FUNC COMMENT END""*********************************************************/
void CDC_snd_char(unsigned char c)
{
	CDC_start_snd( 1, &c );
	while( !(CDC_check_complete(BULK_IN_PIPE)) ){
		/* wait */
	}
}


/*************************************/
/* CDC Recv buffer check (VKǉ)  */
/*************************************/
int CDC_rcv_buffercheck(void)
{
	if (recvcheck == 0) {
		if ( rsz <= 0 ) {
			/* MJn */
			if( CDC_start_rcv( RCV_BUFSIZE, buf ) == 0 ){
				recvcheck = 1;
			}
			return 0;
		} else {
			return rsz;
		}

	} else {
		/* MmF */
		if (CDC_check_complete(BULK_OUT_PIPE)){
			/* M */
			rsz = RCV_BUFSIZE - USBDataCount[ BULK_OUT_PIPE ];
			idx = 0;
			recvcheck = 0;
			return rsz;
		} else {
			return 0;
		}
	}
}


/*""FUNC COMMENT""************************************************************ 
* ID          : 
* Outline     : 1oCgM
*----------------------------------------------------------------------------- 
* Include     : 
*----------------------------------------------------------------------------- 
* Declaration : unsigned char CDC_rcv_char(void);
*----------------------------------------------------------------------------- 
* Description : oNOUT]gpUSBzXgf[^M܂B
*             : Mf[^ꍇ͎Mf[^1oCgAĂяoɕԂ܂B
*             : Mf[^Ȃꍇ͖{֐ő҂܂B
*             : zXg畡oCg̃f[^MꍇɑΉ邽
*             : }bNXpPbgTCY(HS:512byte, FS:64byte)܂ł͂܂Ƃ߂ĎM
*             : Ė{֐ŗpӂobt@ɒ~ςĂ܂B
*----------------------------------------------------------------------------- 
* Argument    : void
*----------------------------------------------------------------------------- 
* Return Value: Mf[^(G[̏ꍇ0xFFԂ)
*----------------------------------------------------------------------------- 
* Notice      : 
*""FUNC COMMENT END""*********************************************************/
unsigned char CDC_rcv_char(void)
{
	unsigned char c;
	
	/* ==== Mς݃f[^Ȃꍇ́AMĎM҂ ==== */
	while( rsz <= 0 ){
		if( CDC_start_rcv( RCV_BUFSIZE, buf ) < 0 ){
			return 0xFF;
		}
		while( !(CDC_check_complete(BULK_OUT_PIPE)) ){
			/* wait */
		}
		rsz = RCV_BUFSIZE - USBDataCount[ BULK_OUT_PIPE ];
		idx = 0;
	}
	/* ==== obt@Mf[^ 1oCgo ==== */
	c = buf[ idx++ ];
	rsz--;
	return c;
}
/*""FUNC COMMENT""************************************************************ 
* ID          : 
* Outline     : f[^MJn
*----------------------------------------------------------------------------- 
* Include     : 
*----------------------------------------------------------------------------- 
* Declaration : int CDC_start_snd( unsigned long size, unsigned char *top );
*----------------------------------------------------------------------------- 
* Description : oNIN]gpāAŎw肳ꂽf[^TCY̑M
*             : f[^USBzXgɑM܂BM̊͑҂ɌĂяo
*             : ߂܂B
*----------------------------------------------------------------------------- 
* Argument    : unsigned long size : I ; Mf[^TCY
*             : unsigned char *top : I ; Mf[^̐擪AhX
*----------------------------------------------------------------------------- 
* Return Value:  0 : MN
*             : -1 : MG[
*----------------------------------------------------------------------------- 
* Notice      : 
*""FUNC COMMENT END""*********************************************************/
int CDC_start_snd( unsigned long size, unsigned char *top )
{
	USB_U16		buffer;
#ifdef USE_INTR 
        USB_U16 	pipe = INTR_IN_PIPE;
#else
	USB_U16 	pipe = BULK_IN_PIPE;
#endif

	/* ---- STALL̏ꍇ̓G[Ԃ ---- */
	buffer = usb_get_pid(pipe);
	if( ( buffer == PID_STALL ) || (buffer == PID_STALL2) ) {
		return -1;
	}
	/* ---- O̎MĂȂꍇ̓G[Ԃ ---- */
	if( (PipeFlag[pipe] != PIPE_IDLE) && (PipeFlag[pipe] != PIPE_DONE) ){
		return -1;
	}
	/* ---- MJnioNIN]j ---- */
	PipeFlag[pipe] = PIPE_WAIT;
	usb_start_send_transfer(pipe, size, top);
	return 0;
}
/*""FUNC COMMENT""************************************************************ 
* ID          : 
* Outline     : f[^MJn
*----------------------------------------------------------------------------- 
* Include     : 
*----------------------------------------------------------------------------- 
* Declaration : int CDC_start_rcv( unsigned long size, unsigned char *buf );
*----------------------------------------------------------------------------- 
* Description : oNOUT]gpāAŎw肳ꂽf[^TCY̎M
*             : f[^USBzXgM܂BM̊͑҂ɌĂяo
*             : ߂܂B
*----------------------------------------------------------------------------- 
* Argument    : unsigned long size : I ; Mf[^TCY
*             : unsigned char *buf : O ; Mobt@̐擪AhX
*----------------------------------------------------------------------------- 
* Return Value:  0 : MN
*             : -1 : MG[
*----------------------------------------------------------------------------- 
* Notice      : 
*""FUNC COMMENT END""*********************************************************/
int CDC_start_rcv( unsigned long size, unsigned char *buf )
{
	USB_U16		buffer;
	USB_U16 	pipe = BULK_OUT_PIPE;
	
	/* ---- STALL̏ꍇ̓G[Ԃ ---- */
	buffer = usb_get_pid(pipe);
	if( ( buffer == PID_STALL ) || (buffer == PID_STALL2) ) {
		return -1;
	}
	/* ---- O̎MĂȂꍇ̓G[Ԃ ---- */
	if( (PipeFlag[pipe] != PIPE_IDLE) && (PipeFlag[pipe] != PIPE_DONE) ){
	
		return -1;
	}
	/* ---- MJnioNOUT]j ---- */
	PipeFlag[pipe] = PIPE_WAIT;
	usb_start_recieve_transfer( pipe, size, buf );
	return 0;
}
/*""FUNC COMMENT""************************************************************ 
* ID          : 
* Outline     : ]̊mF
*----------------------------------------------------------------------------- 
* Include     : 
*----------------------------------------------------------------------------- 
* Declaration : int CDC_check_complete( unsigned short pipe );
*----------------------------------------------------------------------------- 
* Description : Ŏw肵pCv̓]Ăꍇ́A]Ԃ܂B
*----------------------------------------------------------------------------- 
* Argument    : unsigned short pipe : I ; pCvԍ
*----------------------------------------------------------------------------- 
* Return Value: 1 : ]
*             : 0 : ] ܂ STALL/G[
*----------------------------------------------------------------------------- 
* Notice      : 
*""FUNC COMMENT END""*********************************************************/
int CDC_check_complete( unsigned short pipe )
{
	if( (PipeFlag[pipe] == PIPE_IDLE) || (PipeFlag[pipe] == PIPE_DONE) ){
		return 1;
	}
	return 0;
}

/* End of File */
